﻿Imports System
Imports System.IO.Ports

Public Class Form1
    Dim comPORT As String
    Dim receivedData As String = ""
    Dim zone As Int16 = 12

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        For i = -11 To +11
            Dim str As String = ""
            If i < 0 Then
                str = "-"
            ElseIf i > 0 Then
                str = "+"
            End If
            str &= Math.Abs(i)
            Zone_ComboBox.Items.Add(str)
        Next
        Timer1.Enabled = False
        comPORT = ""
        For Each sp As String In My.Computer.Ports.SerialPortNames
            comPort_ComboBox.Items.Add(sp)
        Next
    End Sub

    Private Sub comPort_ComboBox_SelectedIndexChanged(sender As Object, e As EventArgs) Handles comPort_ComboBox.SelectedIndexChanged
        If (comPort_ComboBox.SelectedItem <> "") Then
            comPORT = comPort_ComboBox.SelectedItem
        End If
    End Sub

    Private Sub connect_BTN_Click(sender As Object, e As EventArgs) Handles connect_BTN.Click
        If (connect_BTN.Text = "Connect") Then
            If (comPORT <> "") Then
                SerialPort1.Close()
                SerialPort1.PortName = comPORT
                SerialPort1.BaudRate = 115200
                SerialPort1.DataBits = 8
                SerialPort1.Parity = Parity.None
                SerialPort1.StopBits = StopBits.One
                SerialPort1.Handshake = Handshake.None
                SerialPort1.Encoding = System.Text.Encoding.Default 'very important!
                SerialPort1.ReadTimeout = 10000
                SerialPort1.Open()
                connect_BTN.Text = "Disconnect"
                Timer1.Enabled = True
            Else
                MsgBox("Select a COM port first")
            End If
        Else
            SerialPort1.Close()
            connect_BTN.Text = "Connect"
            Timer1.Enabled = False
        End If
    End Sub

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        receivedData = ReceiveSerialData()
        RichTextBox1.Text &= receivedData
    End Sub

    Function ReceiveSerialData() As String
        Dim Incoming As String
        Try
            Incoming = SerialPort1.ReadExisting()
            If Incoming Is Nothing Then
                Return "nothing" & vbCrLf
            Else
                Return Incoming
            End If
        Catch ex As TimeoutException
            Return "Error: Serial Port read timed out."
        End Try
    End Function

    Private Sub clear_BTN_Click(sender As Object, e As EventArgs) Handles clear_BTN.Click
        RichTextBox1.Text = ""
    End Sub

    Private Sub Send_Button_Click(sender As Object, e As EventArgs) Handles Send_Button.Click
        Dim uTime As Integer
        If zone <> 12 Then
            uTime = (DateTime.UtcNow - New DateTime(1970, 1, 1, 0, 0, 0)).TotalSeconds
            'Button1.Text = uTime & "\n" & Hex(uTime)
            uTime += zone * 3600
            If SerialPort1.IsOpen() Then
                SerialPort1.WriteLine("T" & Hex(uTime))
            Else
                MsgBox("Select and connect to a COM port first")
            End If
        Else
            MsgBox("Select a valid time zone.")
        End If
    End Sub

    Private Sub Zone_ComboBox_SelectedIndexChanged(sender As Object, e As EventArgs) Handles Zone_ComboBox.SelectedIndexChanged
        zone = Zone_ComboBox.SelectedItem
    End Sub

    Private Sub Show_Button_Click(sender As Object, e As EventArgs) Handles Show_Button.Click
        If SerialPort1.IsOpen() Then
            SerialPort1.WriteLine("I")
        Else
            MsgBox("Select and connect to a COM port first")
        End If
    End Sub
End Class
